SetWorkingTransportStateEvent = {};
SetWorkingTransportStateEvent_mt = Class(SetWorkingTransportStateEvent, Event);

InitEventClass(SetWorkingTransportStateEvent, "SetWorkingTransportStateEvent");

function SetWorkingTransportStateEvent:emptyNew()
    local self = Event:new(SetWorkingTransportStateEvent_mt);
    self.className = "SetWorkingTransportStateEvent";
    return self;
end;

function SetWorkingTransportStateEvent:new(object, working, transport)
    local self = SetWorkingTransportStateEvent:emptyNew()
    self.object = object;
	self.working = working;
	self.transport = transport;
    return self;
end;

function SetWorkingTransportStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.working = streamReadBool(streamId);
	self.transport = streamReadBool(streamId);
    self:run(connection);
end;

function SetWorkingTransportStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.working);
	streamWriteBool(streamId, self.transport);
end;

function SetWorkingTransportStateEvent:run(connection)
	self.object:setWorkingTransportState(self.working, self.transport, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetWorkingTransportStateEvent:new(self.object, self.working, self.transport), nil, connection, self.object);
	end;
end;

function SetWorkingTransportStateEvent.sendEvent(vehicle, working, transport, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetWorkingTransportStateEvent:new(vehicle, working, transport), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetWorkingTransportStateEvent:new(vehicle, working, transport));
		end;
	end;
end;

